首页
学习
活动
专区
圈层
工具
发布
社区首页 >问答首页 >INVALID_REQUEST_ERROR - VERSION_MISMATCH -对象版本与最新的数据库版本不匹配。

INVALID_REQUEST_ERROR - VERSION_MISMATCH -对象版本与最新的数据库版本不匹配。
EN

Stack Overflow用户
提问于 2018-08-14 13:34:16
回答 2查看 906关注 0票数 0

我试图使用节点的square-connect包更新正方形目录中的一些数据,如下所示:

我使用的是一个firebase functions函数,它可以在防火墙数据库更新时执行代码(这就是export.updateItem的作用,这是执行的函数,并返回已更新的数据的快照):

代码语言:javascript
复制
exports.updateItem = functions.firestore
    .document('items/{itemId}')
    .onUpdate((change, context) => {
        // Get an object representing the document
        // e.g. {'name': 'Marie', 'age': 66}
        const newValue = change.after.data();
        const previousValue = change.before.data();

        var params = {
            query: {
                exact_query: {
                    attribute_name: "sku",
                    attribute_value: newValue.barcode
                }
            }
        }

        api.searchCatalogObjects(params).then(function(data) {
            console.log('API called successfully in searchFor IDS. Returned data: ' + JSON.stringify(data));

            var dat = data;

            var variation = {
                type: "ITEM_VARIATION",
                id: dat.objects[0].id,
                present_at_all_locations: true,
                item_variation_data: {
                  item_id: dat.objects[0].item_variation_data.item_id,
                  name: "Regular",
                  pricing_type: "FIXED_PRICING",
                  price_money: {
                    amount: Number(newValue.price) * 100,
                    currency: "USD",
                  },
                  sku: newValue.barcode,
                  track_inventory: true
                }
            };

            var item = {
              type: 'ITEM',
              id: dat.objects[0].item_variation_data.item_id,
              item_data: {
                name: newValue.barcode,
                description: newValue.description,
                variations: [variation]
              }
            };

            const idempotencyKey = require('crypto').randomBytes(32).toString('hex');
            var body = {
              idempotency_key: idempotencyKey,
              batches: [{
                objects: [item]
              }]
            };


            api.batchUpsertCatalogObjects(body).then(function(data) {
                console.log('API called successfully in update from EditItem. Returned data: ' + JSON.stringify(data));

                if(newValue.quantity != previousValue.quantity) {

                    var res = data;
                    var variationId = res.objects[0].item_data.variations[0].id;

                    locationApi.listLocations().then(function(data) {
                      console.log('API called successfully in locationApi. Returned data: ' + JSON.stringify(data));

                        var dat = data;
                        var locationId = dat.locations[0].id; // String | The ID of the item's associated location.

                         // String | The ID of the variation to adjust inventory information for.

                        //var body = new SquareConnect.V1AdjustInventoryRequest(); // V1AdjustInventoryRequest | An object containing the fields to POST for the request.  See the corresponding object definition for field details.

                        var adjustBody = {
                            quantity_delta: Number(newValue.quantity) - Number(previousValue.quantity),
                            adjustment_type: 'MANUAL_ADJUST'
                        }

                        inventoryApi.adjustInventory(locationId, variationId, adjustBody).then(function(data) {
                          console.log('API called successfully in inventoryApi. Returned data: ' + JSON.stringify(data));
                        }, function(error) {
                          console.error(error);
                        });
                    }, function(error) {
                      console.error(error);
                    });
                }
            }, function(error) {
              console.error(error);
            });

        }, function(error) {
          console.error(error);
        });

      return null;
    });

firebase函数日志如下所示:

代码语言:javascript
复制
9:02:19.367 AM
updateItem
Function execution started
9:02:21.309 AM
updateItem
Function execution took 1944 ms, finished with status: 'ok'
9:02:31.834 AM
updateItem
API called successfully in searchFor IDS. Returned data: {"objects":[{"type":"ITEM_VARIATION","id":"6WNRO7PULPW7Z4QL73FEVITU","updated_at":"2018-08-14T00:53:50.645Z","version":1534208030645,"is_deleted":false,"present_at_all_locations":true,"item_variation_data":{"item_id":"SUW2HSXCNSERMTGERY4Y54TD","name":"Regular","sku":"0637792505002","ordinal":0,"pricing_type":"FIXED_PRICING","price_money":{"amount":100,"currency":"USD"},"location_overrides":[{"location_id":"JN6S37JH6M1Z2","track_inventory":true}],"track_inventory":true}}]}
9:02:47.035 AM
updateItem
 { Error: Bad Request
    at Request.callback (/user_code/node_modules/square-connect/node_modules/superagent/lib/node/index.js:675:11)
    at /user_code/node_modules/square-connect/node_modules/superagent/lib/node/index.js:883:18
    at Stream.<anonymous> (/user_code/node_modules/square-connect/node_modules/superagent/lib/node/parsers/json.js:16:7)
    at emitNone (events.js:86:13)
    at Stream.emit (events.js:185:7)
    at Unzip.<anonymous> (/user_code/node_modules/square-connect/node_modules/superagent/lib/node/unzip.js:53:12)
    at emitNone (events.js:91:20)
    at Unzip.emit (events.js:185:7)
    at endReadableNT (_stream_readable.js:974:12)
    at _combinedTickCallback (internal/process/next_tick.js:80:11)
  status: 400,
  response: 
   Response {
     domain: null,
     _events: {},
     _eventsCount: 0,
     _maxListeners: undefined,
     res: 
      IncomingMessage {
        _readableState: [Object],
        readable: false,
        domain: null,
        _events: [Object],
        _eventsCount: 3,
        _maxListeners: undefined,
        socket: [Object],
        connection: [Object],
        httpVersionMajor: 1,
        httpVersionMinor: 1,
        httpVersion: '1.1',
        complete: true,
        headers: [Object],
        rawHeaders: [Object],
        trailers: {},
        rawTrailers: [],
        upgrade: false,
        url: '',
        method: null,
        statusCode: 400,
        statusMessage: 'Bad Request',
        client: [Object],
        _consuming: true,
        _dumped: false,
        req: [Object],
        setEncoding: [Function],
        on: [Function],
        text: '{"errors":[{"category":"INVALID_REQUEST_ERROR","code":"VERSION_MISMATCH","detail":"Object version does not match latest database version.","field":"version"}]}',
        read: [Function] },
     request: 
      Request {
        domain: null,
        _events: {},
        _eventsCount: 0,
        _maxListeners: undefined,
        _agent: false,
        _formData: null,
        method: 'POST',
        url: 'https://connect.squareup.com/v2/catalog/batch-upsert',
        _header: [Object],
        header: [Object],
        writable: true,
        _redirects: 0,
        _maxRedirects: 5,
        cookies: '',
        qs: {},
        qsRaw: [],
        _redirectList: [],
        _streamRequest: false,
        _timeout: 60000,
        _responseTimeout: 0,
        _data: [Object],
        req: [Object],
        protocol: 'https:',
        host: 'connect.squareup.com',
        _endCalled: true,
        _callback: [Function],
        res: [Object],
        response: [Circular],
        called: true },
     req: 
      ClientRequest {
        domain: null,
        _events: [Object],
        _eventsCount: 3,
        _maxListeners: undefined,
        output: [],
        outputEncodings: [],
        outputCallbacks: [],
        outputSize: 0,
        writable: true,
        _last: true,
        upgrading: false,
        chunkedEncoding: false,
        shouldKeepAlive: false,
        useChunkedEncodingByDefault: true,
        sendDate: false,
        _removedHeader: [Object],
        _contentLength: 526,
        _hasBody: true,
        _trailer: '',
        finished: true,
        _headerSent: true,
        socket: [Object],
        connection: [Object],
        _header: 'POST /v2/catalog/batch-upsert HTTP/1.1\r\nHost: connect.squareup.com\r\nAccept-Encoding: gzip, deflate\r\nUser-Agent: Square-Connect-Javascript/2.20180712.1\r\nAuthorization: Bearer sq0atp-on5KcHDr0dhlbefU0EwVwg\r\nSquare-Version: 2018-07-12\r\nContent-Type: application/json\r\nAccept: application/json\r\nContent-Length: 526\r\nConnection: close\r\n\r\n',
        _headers: [Object],
        _headerNames: [Object],
        _onPendingData: null,
        agent: [Object],
        socketPath: undefined,
        timeout: undefined,
        method: 'POST',
        path: '/v2/catalog/batch-upsert',
        _ended: true,
        parser: null,
        res: [Object] },
     text: '{"errors":[{"category":"INVALID_REQUEST_ERROR","code":"VERSION_MISMATCH","detail":"Object version does not match latest database version.","field":"version"}]}',
     body: { errors: [Object] },
     files: undefined,
     buffered: true,
     headers: 
      { 'content-encoding': 'gzip',
        'content-type': 'application/json',
        'square-version': '2018-07-12',
        vary: 'Origin, Accept-Encoding',
        'x-content-type-options': 'nosniff',
        'x-download-options': 'noopen',
        'x-frame-options': 'SAMEORIGIN',
        'x-permitted-cross-domain-policies': 'none',
        'x-xss-protection': '1; mode=block',
        date: 'Tue, 14 Aug 2018 13:02:39 GMT',
        'keep-alive': 'timeout=60',
        'strict-transport-security': 'max-age=631152000',
        'content-length': '159',
        connection: 'close' },
     header: 
      { 'content-encoding': 'gzip',
        'content-type': 'application/json',
        'square-version': '2018-07-12',
        vary: 'Origin, Accept-Enco

Bad request信息中,您可以在text属性中看到错误:

代码语言:javascript
复制
text: '{"errors":[{"category":"INVALID_REQUEST_ERROR","code":"VERSION_MISMATCH","detail":"Object version does not match latest database version.","field":"version"}]}'

当我查找数据时,我会看到一个版本属性,例如,一个正方形的ITEM_VARIATION,它看起来如下:

代码语言:javascript
复制
"version":1534208030645

在上面的输出文本之后,您可以在对象中看到它:

在searchFor入侵检测系统中成功调用了API。返回的数据:

它显示在搜索ITEM_VARIATION时返回的数据中。我尝试过将这个字段和值放入batchUpsertCatalogObjects请求中,但是它似乎没有帮助--我相信我在尝试这样做时又收到了另一个错误(我不记得它是什么,或者现在在日志中找到它)。

任何帮助都将不胜感激。

更新

我尝试将version: dat.objects[0].version添加到item对象中,但是没有帮助。

更新

我试过这个:

代码语言:javascript
复制
var variationObj = dat.objects[0];

variationObj.item_variation_data.price_money =  {amount: Number(newValue.price) * 100, currency: 'USD'};

var item = {
              type: 'ITEM',
              id: dat.objects[0].item_variation_data.item_id,
              item_data: {
                name: newValue.barcode,
                description: newValue.description,
                variations: [variationObj]
           }
};

尽管如此,我仍然会得到相同的错误--即使我使用了从查询中返回给我的相同的确切对象。

更新

上面的更新是有效的--见答案。

EN

回答 2

Stack Overflow用户

发布于 2018-08-14 21:41:32

这样做的诀窍似乎是直接从响应中获取我需要的对象,并像responseObj.xxxxxxx = xxxxxxxx一样编辑它,而不是尝试使用{}表示法自己创建一个对象,然后将该对象作为必要的参数传递。而且,firebase deploy有时似乎需要重新运行,才能使更改生效。

我似乎也需要使用uspsertCatalogObject分别上传ITEMITEM_VARIATION,而不是将ITEM_VARITION包含在ITEMvariations字段中,或者使用batchUpsertCatalogObject和包含在batches数组中的ITEMITEM_VARIATION --这似乎也不起作用。

票数 0
EN

Stack Overflow用户

发布于 2021-11-25 16:03:32

根据Square API文档:

版本=>对象的版本。更新对象时,所提供的版本必须与数据库中的版本相匹配,否则,写入将因冲突而被拒绝。

因此,当您获得对象时,您将拥有一个具有版本号的属性,您只需要在更新目录对象时传递该值。(无论是产品还是变体)

下面是使用version字段更新产品目录的最简单JSON请求的示例。

代码语言:javascript
复制
    "object": {
      "type": "ITEM",
      },
      "id": "7R55G27F2LHH2VUJ7ZONKWRA",
      "item_data": {
        "product_type": "REGULAR",
        "variations": [
          {
            "id": "GQTI2KPZHXNM33QJAJJLAGWC",
            "type": "ITEM_VARIATION",
            "item_data": {
              "name": "cenas variant",
              "product_type": "REGULAR"
            },
            "item_variation_data": {
              "track_inventory": false,
              "pricing_type": "FIXED_PRICING",
              "price_money": {
                "amount": 50,
                "currency": "AUD"
              }
            },
            "version": 1637854673484
          }
        ],
        "name": "UPDATE DE PRODUTO"
      },
      "version": 1637854673484
    },
    "idempotency_key": "ffe8498d-6313-45c8-b772-13c2dbc77b4b"
  }'
票数 0
EN
页面原文内容由Stack Overflow提供。腾讯云小微IT领域专用引擎提供翻译支持
原文链接:

https://stackoverflow.com/questions/51842778

复制
相关文章

相似问题

领券
问题归档专栏文章快讯文章归档关键词归档开发者手册归档开发者手册 Section 归档